/* clipboard-menu.c generated by valac 0.30.2, the Vala compiler
 * generated from clipboard-menu.vala, do not modify */

/*
 * Diodon - GTK+ clipboard manager.
 * Copyright (C) 2011 Diodon Team <diodon-team@lists.launchpad.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Oliver Sauder <os@esite.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>


#define DIODON_TYPE_CLIPBOARD_MENU (diodon_clipboard_menu_get_type ())
#define DIODON_CLIPBOARD_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_CLIPBOARD_MENU, DiodonClipboardMenu))
#define DIODON_CLIPBOARD_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_CLIPBOARD_MENU, DiodonClipboardMenuClass))
#define DIODON_IS_CLIPBOARD_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_CLIPBOARD_MENU))
#define DIODON_IS_CLIPBOARD_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_CLIPBOARD_MENU))
#define DIODON_CLIPBOARD_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_CLIPBOARD_MENU, DiodonClipboardMenuClass))

typedef struct _DiodonClipboardMenu DiodonClipboardMenu;
typedef struct _DiodonClipboardMenuClass DiodonClipboardMenuClass;
typedef struct _DiodonClipboardMenuPrivate DiodonClipboardMenuPrivate;

#define DIODON_TYPE_CONTROLLER (diodon_controller_get_type ())
#define DIODON_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_CONTROLLER, DiodonController))
#define DIODON_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_CONTROLLER, DiodonControllerClass))
#define DIODON_IS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_CONTROLLER))
#define DIODON_IS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_CONTROLLER))
#define DIODON_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_CONTROLLER, DiodonControllerClass))

typedef struct _DiodonController DiodonController;
typedef struct _DiodonControllerClass DiodonControllerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DIODON_TYPE_ICLIPBOARD_ITEM (diodon_iclipboard_item_get_type ())
#define DIODON_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem))
#define DIODON_IS_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM))
#define DIODON_ICLIPBOARD_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItemIface))

typedef struct _DiodonIClipboardItem DiodonIClipboardItem;
typedef struct _DiodonIClipboardItemIface DiodonIClipboardItemIface;

#define DIODON_TYPE_CLIPBOARD_TYPE (diodon_clipboard_type_get_type ())

#define DIODON_TYPE_CLIPBOARD_CATEGORY (diodon_clipboard_category_get_type ())

#define DIODON_TYPE_CLIPBOARD_MENU_ITEM (diodon_clipboard_menu_item_get_type ())
#define DIODON_CLIPBOARD_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_CLIPBOARD_MENU_ITEM, DiodonClipboardMenuItem))
#define DIODON_CLIPBOARD_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_CLIPBOARD_MENU_ITEM, DiodonClipboardMenuItemClass))
#define DIODON_IS_CLIPBOARD_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_CLIPBOARD_MENU_ITEM))
#define DIODON_IS_CLIPBOARD_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_CLIPBOARD_MENU_ITEM))
#define DIODON_CLIPBOARD_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_CLIPBOARD_MENU_ITEM, DiodonClipboardMenuItemClass))

typedef struct _DiodonClipboardMenuItem DiodonClipboardMenuItem;
typedef struct _DiodonClipboardMenuItemClass DiodonClipboardMenuItemClass;
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DiodonClipboardMenu {
	GtkMenu parent_instance;
	DiodonClipboardMenuPrivate * priv;
};

struct _DiodonClipboardMenuClass {
	GtkMenuClass parent_class;
};

struct _DiodonClipboardMenuPrivate {
	DiodonController* controller;
	GeeList* static_menu_items;
};

typedef enum  {
	DIODON_CLIPBOARD_TYPE_NONE,
	DIODON_CLIPBOARD_TYPE_CLIPBOARD,
	DIODON_CLIPBOARD_TYPE_PRIMARY
} DiodonClipboardType;

typedef enum  {
	DIODON_CLIPBOARD_CATEGORY_CLIPBOARD = 0,
	DIODON_CLIPBOARD_CATEGORY_TEXT,
	DIODON_CLIPBOARD_CATEGORY_FILES,
	DIODON_CLIPBOARD_CATEGORY_IMAGES
} DiodonClipboardCategory;

struct _DiodonIClipboardItemIface {
	GTypeInterface parent_iface;
	DiodonClipboardType (*get_clipboard_type) (DiodonIClipboardItem* self);
	gchar* (*get_label) (DiodonIClipboardItem* self);
	gchar* (*get_mime_type) (DiodonIClipboardItem* self);
	DiodonClipboardCategory (*get_category) (DiodonIClipboardItem* self);
	GtkImage* (*get_image) (DiodonIClipboardItem* self);
	GIcon* (*get_icon) (DiodonIClipboardItem* self);
	GByteArray* (*get_payload) (DiodonIClipboardItem* self, GError** error);
	GDateTime* (*get_date_copied) (DiodonIClipboardItem* self);
	gchar* (*get_text) (DiodonIClipboardItem* self);
	gchar* (*get_checksum) (DiodonIClipboardItem* self);
	gchar* (*get_origin) (DiodonIClipboardItem* self);
	void (*to_clipboard) (DiodonIClipboardItem* self, GtkClipboard* clipboard);
	gboolean (*equals) (DiodonIClipboardItem* self, DiodonIClipboardItem* item);
	guint (*hash) (DiodonIClipboardItem* self);
};


static gpointer diodon_clipboard_menu_parent_class = NULL;

GType diodon_clipboard_menu_get_type (void) G_GNUC_CONST;
GType diodon_controller_get_type (void) G_GNUC_CONST;
#define DIODON_CLIPBOARD_MENU_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIODON_TYPE_CLIPBOARD_MENU, DiodonClipboardMenuPrivate))
enum  {
	DIODON_CLIPBOARD_MENU_DUMMY_PROPERTY
};
GType diodon_clipboard_type_get_type (void) G_GNUC_CONST;
GType diodon_clipboard_category_get_type (void) G_GNUC_CONST;
GType diodon_iclipboard_item_get_type (void) G_GNUC_CONST;
DiodonClipboardMenu* diodon_clipboard_menu_new (DiodonController* controller, GeeList* items, GeeList* static_menu_items);
DiodonClipboardMenu* diodon_clipboard_menu_construct (GType object_type, DiodonController* controller, GeeList* items, GeeList* static_menu_items);
void diodon_clipboard_menu_append_clipboard_item (DiodonClipboardMenu* self, DiodonIClipboardItem* item);
static void diodon_clipboard_menu_on_clicked_clear (DiodonClipboardMenu* self);
static void _diodon_clipboard_menu_on_clicked_clear_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void diodon_clipboard_menu_on_clicked_preferences (DiodonClipboardMenu* self);
static void _diodon_clipboard_menu_on_clicked_preferences_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void diodon_clipboard_menu_on_clicked_quit (DiodonClipboardMenu* self);
static void _diodon_clipboard_menu_on_clicked_quit_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
GType diodon_clipboard_menu_item_get_type (void) G_GNUC_CONST;
DiodonClipboardMenuItem* diodon_clipboard_menu_item_new (DiodonIClipboardItem* item);
DiodonClipboardMenuItem* diodon_clipboard_menu_item_construct (GType object_type, DiodonIClipboardItem* item);
static void diodon_clipboard_menu_on_clicked_item (DiodonClipboardMenu* self, GtkMenuItem* menu_item);
static void _diodon_clipboard_menu_on_clicked_item_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
void diodon_clipboard_menu_show_menu (DiodonClipboardMenu* self);
void diodon_clipboard_menu_destroy_menu (DiodonClipboardMenu* self);
void diodon_controller_clear (DiodonController* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void diodon_controller_clear_finish (DiodonController* self, GAsyncResult* _res_);
void diodon_controller_show_preferences (DiodonController* self);
void diodon_controller_quit (DiodonController* self);
void diodon_controller_select_item_by_checksum (DiodonController* self, const gchar* checksum, GAsyncReadyCallback _callback_, gpointer _user_data_);
void diodon_controller_select_item_by_checksum_finish (DiodonController* self, GAsyncResult* _res_);
gchar* diodon_clipboard_menu_item_get_item_checksum (DiodonClipboardMenuItem* self);
static void diodon_clipboard_menu_finalize (GObject* obj);


/**
         * Create clipboard menu
         *
         * @param controller reference to controller
         * @param items clipboard items to be shown
         * @param menu_items additional menu items to be added after separator
         */
static gpointer _g_object_ref0 (gpointer self) {
#line 41 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	return self ? g_object_ref (self) : NULL;
#line 175 "clipboard-menu.c"
}


static void _diodon_clipboard_menu_on_clicked_clear_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	diodon_clipboard_menu_on_clicked_clear ((DiodonClipboardMenu*) self);
#line 182 "clipboard-menu.c"
}


static void _diodon_clipboard_menu_on_clicked_preferences_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 68 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	diodon_clipboard_menu_on_clicked_preferences ((DiodonClipboardMenu*) self);
#line 189 "clipboard-menu.c"
}


static void _diodon_clipboard_menu_on_clicked_quit_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	diodon_clipboard_menu_on_clicked_quit ((DiodonClipboardMenu*) self);
#line 196 "clipboard-menu.c"
}


DiodonClipboardMenu* diodon_clipboard_menu_construct (GType object_type, DiodonController* controller, GeeList* items, GeeList* static_menu_items) {
	DiodonClipboardMenu * self = NULL;
	DiodonController* _tmp0_ = NULL;
	DiodonController* _tmp1_ = NULL;
	GeeList* _tmp2_ = NULL;
	GeeList* _tmp3_ = NULL;
	GeeList* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GtkSeparatorMenuItem* sep_item = NULL;
	GtkSeparatorMenuItem* _tmp23_ = NULL;
	GtkSeparatorMenuItem* _tmp24_ = NULL;
	GeeList* _tmp25_ = NULL;
	GtkMenuItem* clear_item = NULL;
	GtkImageMenuItem* _tmp38_ = NULL;
	GtkMenuItem* preferences_item = NULL;
	GtkImageMenuItem* _tmp39_ = NULL;
	GtkMenuItem* quit_item = NULL;
	GtkImageMenuItem* _tmp40_ = NULL;
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_return_val_if_fail (DIODON_IS_CONTROLLER (controller), NULL);
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_return_val_if_fail (GEE_IS_LIST (items), NULL);
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_return_val_if_fail ((static_menu_items == NULL) || GEE_IS_LIST (static_menu_items), NULL);
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	self = (DiodonClipboardMenu*) g_object_new (object_type, NULL);
#line 41 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp0_ = controller;
#line 41 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 41 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_g_object_unref0 (self->priv->controller);
#line 41 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	self->priv->controller = _tmp1_;
#line 42 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp2_ = static_menu_items;
#line 42 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 42 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_g_object_unref0 (self->priv->static_menu_items);
#line 42 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	self->priv->static_menu_items = _tmp3_;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp4_ = items;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp5_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp6_ = _tmp5_;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	if (_tmp6_ <= 0) {
#line 251 "clipboard-menu.c"
		GtkMenuItem* empty_item = NULL;
		const gchar* _tmp7_ = NULL;
		GtkMenuItem* _tmp8_ = NULL;
		GtkMenuItem* _tmp9_ = NULL;
		GtkMenuItem* _tmp10_ = NULL;
#line 45 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_tmp7_ = _ ("<Empty>");
#line 45 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_tmp8_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp7_);
#line 45 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		g_object_ref_sink (_tmp8_);
#line 45 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		empty_item = _tmp8_;
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_tmp9_ = empty_item;
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 47 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_tmp10_ = empty_item;
#line 47 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		gtk_menu_shell_append (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_menu_shell_get_type (), GtkMenuShell), (GtkWidget*) _tmp10_);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_g_object_unref0 (empty_item);
#line 275 "clipboard-menu.c"
	}
	{
		GeeList* _item_list = NULL;
		GeeList* _tmp11_ = NULL;
		GeeList* _tmp12_ = NULL;
		gint _item_size = 0;
		GeeList* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gint _item_index = 0;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_tmp11_ = items;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_item_list = _tmp12_;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_tmp13_ = _item_list;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_tmp14_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection));
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_tmp15_ = _tmp14_;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_item_size = _tmp15_;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_item_index = -1;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		while (TRUE) {
#line 304 "clipboard-menu.c"
			gint _tmp16_ = 0;
			gint _tmp17_ = 0;
			gint _tmp18_ = 0;
			DiodonIClipboardItem* item = NULL;
			GeeList* _tmp19_ = NULL;
			gint _tmp20_ = 0;
			gpointer _tmp21_ = NULL;
			DiodonIClipboardItem* _tmp22_ = NULL;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp16_ = _item_index;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_item_index = _tmp16_ + 1;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp17_ = _item_index;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp18_ = _item_size;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			if (!(_tmp17_ < _tmp18_)) {
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				break;
#line 325 "clipboard-menu.c"
			}
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp19_ = _item_list;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp20_ = _item_index;
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp21_ = gee_list_get (_tmp19_, _tmp20_);
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			item = (DiodonIClipboardItem*) _tmp21_;
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp22_ = item;
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			diodon_clipboard_menu_append_clipboard_item (self, _tmp22_);
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_g_object_unref0 (item);
#line 341 "clipboard-menu.c"
		}
#line 50 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_g_object_unref0 (_item_list);
#line 345 "clipboard-menu.c"
	}
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp23_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_object_ref_sink (_tmp23_);
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	sep_item = _tmp23_;
#line 55 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp24_ = sep_item;
#line 55 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	gtk_menu_shell_append (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_menu_shell_get_type (), GtkMenuShell), (GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_menu_item_get_type (), GtkMenuItem));
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp25_ = static_menu_items;
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	if (_tmp25_ != NULL) {
#line 361 "clipboard-menu.c"
		{
			GeeList* _menu_item_list = NULL;
			GeeList* _tmp26_ = NULL;
			GeeList* _tmp27_ = NULL;
			gint _menu_item_size = 0;
			GeeList* _tmp28_ = NULL;
			gint _tmp29_ = 0;
			gint _tmp30_ = 0;
			gint _menu_item_index = 0;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp26_ = static_menu_items;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp27_ = _g_object_ref0 (_tmp26_);
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_menu_item_list = _tmp27_;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp28_ = _menu_item_list;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp29_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_COLLECTION, GeeCollection));
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp30_ = _tmp29_;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_menu_item_size = _tmp30_;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_menu_item_index = -1;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			while (TRUE) {
#line 389 "clipboard-menu.c"
				gint _tmp31_ = 0;
				gint _tmp32_ = 0;
				gint _tmp33_ = 0;
				GtkMenuItem* menu_item = NULL;
				GeeList* _tmp34_ = NULL;
				gint _tmp35_ = 0;
				gpointer _tmp36_ = NULL;
				GtkMenuItem* _tmp37_ = NULL;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				_tmp31_ = _menu_item_index;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				_menu_item_index = _tmp31_ + 1;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				_tmp32_ = _menu_item_index;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				_tmp33_ = _menu_item_size;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				if (!(_tmp32_ < _tmp33_)) {
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
					break;
#line 410 "clipboard-menu.c"
				}
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				_tmp34_ = _menu_item_list;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				_tmp35_ = _menu_item_index;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				_tmp36_ = gee_list_get (_tmp34_, _tmp35_);
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				menu_item = (GtkMenuItem*) _tmp36_;
#line 59 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				_tmp37_ = menu_item;
#line 59 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				gtk_menu_shell_append (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_menu_shell_get_type (), GtkMenuShell), (GtkWidget*) _tmp37_);
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				_g_object_unref0 (menu_item);
#line 426 "clipboard-menu.c"
			}
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_g_object_unref0 (_menu_item_list);
#line 430 "clipboard-menu.c"
		}
	}
#line 63 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp38_ = (GtkImageMenuItem*) gtk_image_menu_item_new_from_stock (GTK_STOCK_CLEAR, NULL);
#line 63 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_object_ref_sink (_tmp38_);
#line 63 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	clear_item = G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, gtk_menu_item_get_type (), GtkMenuItem);
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_signal_connect_object (clear_item, "activate", (GCallback) _diodon_clipboard_menu_on_clicked_clear_gtk_menu_item_activate, self, 0);
#line 65 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	gtk_menu_shell_append (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_menu_shell_get_type (), GtkMenuShell), (GtkWidget*) clear_item);
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp39_ = (GtkImageMenuItem*) gtk_image_menu_item_new_from_stock (GTK_STOCK_PREFERENCES, NULL);
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_object_ref_sink (_tmp39_);
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	preferences_item = G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_menu_item_get_type (), GtkMenuItem);
#line 68 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_signal_connect_object (preferences_item, "activate", (GCallback) _diodon_clipboard_menu_on_clicked_preferences_gtk_menu_item_activate, self, 0);
#line 69 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	gtk_menu_shell_append (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_menu_shell_get_type (), GtkMenuShell), (GtkWidget*) preferences_item);
#line 71 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp40_ = (GtkImageMenuItem*) gtk_image_menu_item_new_from_stock (GTK_STOCK_QUIT, NULL);
#line 71 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_object_ref_sink (_tmp40_);
#line 71 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	quit_item = G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, gtk_menu_item_get_type (), GtkMenuItem);
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_signal_connect_object (quit_item, "activate", (GCallback) _diodon_clipboard_menu_on_clicked_quit_gtk_menu_item_activate, self, 0);
#line 73 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	gtk_menu_shell_append (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_menu_shell_get_type (), GtkMenuShell), (GtkWidget*) quit_item);
#line 75 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_g_object_unref0 (quit_item);
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_g_object_unref0 (preferences_item);
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_g_object_unref0 (clear_item);
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_g_object_unref0 (sep_item);
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	return self;
#line 475 "clipboard-menu.c"
}


DiodonClipboardMenu* diodon_clipboard_menu_new (DiodonController* controller, GeeList* items, GeeList* static_menu_items) {
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	return diodon_clipboard_menu_construct (DIODON_TYPE_CLIPBOARD_MENU, controller, items, static_menu_items);
#line 482 "clipboard-menu.c"
}


/**
         * Append given clipboard item to menu.
         * 
         * @param entry entry to be added
         */
static void _diodon_clipboard_menu_on_clicked_item_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	diodon_clipboard_menu_on_clicked_item ((DiodonClipboardMenu*) self, _sender);
#line 494 "clipboard-menu.c"
}


void diodon_clipboard_menu_append_clipboard_item (DiodonClipboardMenu* self, DiodonIClipboardItem* item) {
	DiodonClipboardMenuItem* menu_item = NULL;
	DiodonIClipboardItem* _tmp0_ = NULL;
	DiodonClipboardMenuItem* _tmp1_ = NULL;
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MENU (self));
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_return_if_fail (DIODON_IS_ICLIPBOARD_ITEM (item));
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp0_ = item;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp1_ = diodon_clipboard_menu_item_new (_tmp0_);
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_object_ref_sink (_tmp1_);
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	menu_item = _tmp1_;
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (menu_item, gtk_menu_item_get_type (), GtkMenuItem), "activate", (GCallback) _diodon_clipboard_menu_on_clicked_item_gtk_menu_item_activate, self, 0);
#line 87 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (menu_item, gtk_widget_get_type (), GtkWidget));
#line 88 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	gtk_menu_shell_append (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_menu_shell_get_type (), GtkMenuShell), (GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (menu_item, gtk_menu_item_get_type (), GtkMenuItem));
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_g_object_unref0 (menu_item);
#line 522 "clipboard-menu.c"
}


void diodon_clipboard_menu_show_menu (DiodonClipboardMenu* self) {
	guint32 _tmp0_ = 0U;
#line 91 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MENU (self));
#line 93 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp0_ = gtk_get_current_event_time ();
#line 93 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	gtk_menu_popup (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_menu_get_type (), GtkMenu), NULL, NULL, NULL, NULL, (guint) 0, _tmp0_);
#line 534 "clipboard-menu.c"
}


/**
         * Completely destroy menu by cleaning up menu items and menu itself.
         */
void diodon_clipboard_menu_destroy_menu (DiodonClipboardMenu* self) {
	GList* _tmp0_ = NULL;
#line 99 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MENU (self));
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer));
#line 547 "clipboard-menu.c"
	{
		GList* item_collection = NULL;
		GList* item_it = NULL;
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		item_collection = _tmp0_;
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 555 "clipboard-menu.c"
			GtkWidget* _tmp1_ = NULL;
			GtkWidget* item = NULL;
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			_tmp1_ = _g_object_ref0 ((GtkWidget*) item_it->data);
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
			item = _tmp1_;
#line 562 "clipboard-menu.c"
			{
				GtkWidget* _tmp2_ = NULL;
				gboolean _tmp3_ = FALSE;
				GeeList* _tmp4_ = NULL;
#line 102 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				_tmp2_ = item;
#line 102 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), _tmp2_);
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				_tmp4_ = self->priv->static_menu_items;
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				if (_tmp4_ == NULL) {
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
					_tmp3_ = TRUE;
#line 577 "clipboard-menu.c"
				} else {
					GeeList* _tmp5_ = NULL;
					GtkWidget* _tmp6_ = NULL;
					gboolean _tmp7_ = FALSE;
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
					_tmp5_ = self->priv->static_menu_items;
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
					_tmp6_ = item;
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
					_tmp7_ = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection), _tmp6_);
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
					_tmp3_ = !_tmp7_;
#line 590 "clipboard-menu.c"
				}
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				if (_tmp3_) {
#line 594 "clipboard-menu.c"
					GtkWidget* _tmp8_ = NULL;
					GtkWidget* _tmp9_ = NULL;
#line 107 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
					_tmp8_ = item;
#line 107 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
					gtk_widget_destroy (_tmp8_);
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
					_tmp9_ = item;
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
					g_object_run_dispose (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, G_TYPE_OBJECT, GObject));
#line 605 "clipboard-menu.c"
				}
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
				_g_object_unref0 (item);
#line 609 "clipboard-menu.c"
			}
		}
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
		_g_list_free0 (item_collection);
#line 614 "clipboard-menu.c"
	}
#line 112 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 113 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_object_run_dispose (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
#line 620 "clipboard-menu.c"
}


/**
         * User event: clicked menu item clear
         */
static void diodon_clipboard_menu_on_clicked_clear (DiodonClipboardMenu* self) {
	DiodonController* _tmp0_ = NULL;
#line 119 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MENU (self));
#line 121 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp0_ = self->priv->controller;
#line 121 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	diodon_controller_clear (_tmp0_, NULL, NULL);
#line 635 "clipboard-menu.c"
}


/**
         * User event: clicked menu item preferences
         */
static void diodon_clipboard_menu_on_clicked_preferences (DiodonClipboardMenu* self) {
	DiodonController* _tmp0_ = NULL;
#line 127 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MENU (self));
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp0_ = self->priv->controller;
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	diodon_controller_show_preferences (_tmp0_);
#line 650 "clipboard-menu.c"
}


/**
         * User event: clicked menu item quit
         */
static void diodon_clipboard_menu_on_clicked_quit (DiodonClipboardMenu* self) {
	DiodonController* _tmp0_ = NULL;
#line 135 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MENU (self));
#line 137 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp0_ = self->priv->controller;
#line 137 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	diodon_controller_quit (_tmp0_);
#line 665 "clipboard-menu.c"
}


/**
         * User event: clicked clipboard menu item
         * 
         * @param menu_item menu item clicked
         */
static void diodon_clipboard_menu_on_clicked_item (DiodonClipboardMenu* self, GtkMenuItem* menu_item) {
	DiodonClipboardMenuItem* clipboard_menu_item = NULL;
	GtkMenuItem* _tmp0_ = NULL;
	DiodonClipboardMenuItem* _tmp1_ = NULL;
	DiodonController* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
#line 145 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MENU (self));
#line 145 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_return_if_fail (GTK_IS_MENU_ITEM (menu_item));
#line 147 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp0_ = menu_item;
#line 147 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, DIODON_TYPE_CLIPBOARD_MENU_ITEM, DiodonClipboardMenuItem));
#line 147 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	clipboard_menu_item = _tmp1_;
#line 148 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp2_ = self->priv->controller;
#line 148 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp3_ = diodon_clipboard_menu_item_get_item_checksum (clipboard_menu_item);
#line 148 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_tmp4_ = _tmp3_;
#line 148 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	diodon_controller_select_item_by_checksum (_tmp2_, _tmp4_, NULL, NULL);
#line 148 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_g_free0 (_tmp4_);
#line 145 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_g_object_unref0 (clipboard_menu_item);
#line 703 "clipboard-menu.c"
}


static void diodon_clipboard_menu_class_init (DiodonClipboardMenuClass * klass) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	diodon_clipboard_menu_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	g_type_class_add_private (klass, sizeof (DiodonClipboardMenuPrivate));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	G_OBJECT_CLASS (klass)->finalize = diodon_clipboard_menu_finalize;
#line 714 "clipboard-menu.c"
}


static void diodon_clipboard_menu_instance_init (DiodonClipboardMenu * self) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	self->priv = DIODON_CLIPBOARD_MENU_GET_PRIVATE (self);
#line 721 "clipboard-menu.c"
}


static void diodon_clipboard_menu_finalize (GObject* obj) {
	DiodonClipboardMenu * self;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIODON_TYPE_CLIPBOARD_MENU, DiodonClipboardMenu);
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_g_object_unref0 (self->priv->controller);
#line 30 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	_g_object_unref0 (self->priv->static_menu_items);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu.vala"
	G_OBJECT_CLASS (diodon_clipboard_menu_parent_class)->finalize (obj);
#line 735 "clipboard-menu.c"
}


/**
     * A gtk menu item holding a list of clipboard items
     */
GType diodon_clipboard_menu_get_type (void) {
	static volatile gsize diodon_clipboard_menu_type_id__volatile = 0;
	if (g_once_init_enter (&diodon_clipboard_menu_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DiodonClipboardMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diodon_clipboard_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DiodonClipboardMenu), 0, (GInstanceInitFunc) diodon_clipboard_menu_instance_init, NULL };
		GType diodon_clipboard_menu_type_id;
		diodon_clipboard_menu_type_id = g_type_register_static (gtk_menu_get_type (), "DiodonClipboardMenu", &g_define_type_info, 0);
		g_once_init_leave (&diodon_clipboard_menu_type_id__volatile, diodon_clipboard_menu_type_id);
	}
	return diodon_clipboard_menu_type_id__volatile;
}



