/* utility.c generated by valac 0.30.2, the Vala compiler
 * generated from utility.vala, do not modify */

/*
 * Diodon - GTK+ clipboard manager.
 * Copyright (C) 2011 Diodon Team <diodon-team@lists.launchpad.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Oliver Sauder <os@esite.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <X11/extensions/XTest.h>


#define DIODON_TYPE_UTILITY (diodon_utility_get_type ())
#define DIODON_UTILITY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_UTILITY, DiodonUtility))
#define DIODON_UTILITY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_UTILITY, DiodonUtilityClass))
#define DIODON_IS_UTILITY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_UTILITY))
#define DIODON_IS_UTILITY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_UTILITY))
#define DIODON_UTILITY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_UTILITY, DiodonUtilityClass))

typedef struct _DiodonUtility DiodonUtility;
typedef struct _DiodonUtilityClass DiodonUtilityClass;
typedef struct _DiodonUtilityPrivate DiodonUtilityPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DiodonUtility {
	GObject parent_instance;
	DiodonUtilityPrivate * priv;
};

struct _DiodonUtilityClass {
	GObjectClass parent_class;
};


static gpointer diodon_utility_parent_class = NULL;

GType diodon_utility_get_type (void) G_GNUC_CONST;
enum  {
	DIODON_UTILITY_DUMMY_PROPERTY
};
gchar* diodon_utility_get_user_data_dir (void);
gboolean diodon_utility_make_directory_with_parents (const gchar* directory);
gchar* diodon_utility_get_path_of_active_application (void);
static Window diodon_utility_get_active_window (void);
static gulong diodon_utility_get_pid (Window window);
gboolean diodon_utility_perform_key_event (const gchar* accelerator, gboolean press, gulong delay);
DiodonUtility* diodon_utility_construct (GType object_type);


/**
         * Get diodon user data dir.
         *
         * @return path to diodon user data dir
         */
gchar* diodon_utility_get_user_data_dir (void) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 36 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 36 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp1_ = g_build_filename (_tmp0_, PACKAGE_NAME, NULL);
#line 36 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	result = _tmp1_;
#line 36 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	return result;
#line 98 "utility.c"
}


/**
         * Create directory with all its parents logging error if not successful.
         * Checks first if directory already exists.
         *
         * @param directory directory to be created
         * @return returns true if directory already exists or creation was successful
         */
gboolean diodon_utility_make_directory_with_parents (const gchar* directory) {
	gboolean result = FALSE;
	gboolean _result_ = FALSE;
	GError * _inner_error_ = NULL;
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	g_return_val_if_fail (directory != NULL, FALSE);
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_result_ = TRUE;
#line 117 "utility.c"
	{
		GFile* dir = NULL;
		const gchar* _tmp0_ = NULL;
		GFile* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
#line 52 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp0_ = directory;
#line 52 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp1_ = g_file_new_for_path (_tmp0_);
#line 52 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		dir = _tmp1_;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp2_ = dir;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp3_ = g_file_query_exists (_tmp2_, NULL);
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		if (!_tmp3_) {
#line 136 "utility.c"
			gboolean _tmp4_ = FALSE;
			GFile* _tmp5_ = NULL;
			gboolean _tmp6_ = FALSE;
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp5_ = dir;
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp6_ = g_file_make_directory_with_parents (_tmp5_, NULL, &_inner_error_);
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp4_ = _tmp6_;
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_g_object_unref0 (dir);
#line 150 "utility.c"
				goto __catch10_g_error;
			}
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_result_ = _tmp4_;
#line 155 "utility.c"
		}
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_g_object_unref0 (dir);
#line 159 "utility.c"
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp7_ = NULL;
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		e = _inner_error_;
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_inner_error_ = NULL;
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp7_ = directory;
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		g_warning ("utility.vala:57: could not create directory %s", _tmp7_);
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_result_ = FALSE;
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_g_error_free0 (e);
#line 178 "utility.c"
	}
	__finally10:
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		g_clear_error (&_inner_error_);
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		return FALSE;
#line 189 "utility.c"
	}
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	result = _result_;
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	return result;
#line 195 "utility.c"
}


/**
         * Get executable path of application which is currently running.
         *
         * @return path of currently active application or null if not possible to determine
         */
gchar* diodon_utility_get_path_of_active_application (void) {
	gchar* result = NULL;
	gchar* path = NULL;
	Window window = 0;
	Window _tmp0_ = 0;
	Window _tmp1_ = 0;
	GError * _inner_error_ = NULL;
#line 71 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	gdk_error_trap_push ();
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	path = NULL;
#line 74 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp0_ = diodon_utility_get_active_window ();
#line 74 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	window = _tmp0_;
#line 75 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp1_ = window;
#line 75 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	if (_tmp1_ != ((Window) None)) {
#line 223 "utility.c"
		gulong pid = 0UL;
		Window _tmp2_ = 0;
		gulong _tmp3_ = 0UL;
		gulong _tmp4_ = 0UL;
#line 76 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp2_ = window;
#line 76 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp3_ = diodon_utility_get_pid (_tmp2_);
#line 76 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		pid = _tmp3_;
#line 78 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp4_ = pid;
#line 78 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		if (_tmp4_ != ((gulong) 0)) {
#line 238 "utility.c"
			GFile* file = NULL;
			gulong _tmp5_ = 0UL;
			gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			gchar* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			GFile* _tmp12_ = NULL;
			GFile* _tmp13_ = NULL;
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp5_ = pid;
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp6_ = g_strdup_printf ("%lu", _tmp5_);
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp7_ = _tmp6_;
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp8_ = g_strconcat ("/proc/", _tmp7_, NULL);
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp9_ = _tmp8_;
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp10_ = g_strconcat (_tmp9_, "/exe", NULL);
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp11_ = _tmp10_;
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp12_ = g_file_new_for_path (_tmp11_);
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp13_ = _tmp12_;
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_g_free0 (_tmp11_);
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_g_free0 (_tmp9_);
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_g_free0 (_tmp7_);
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			file = _tmp13_;
#line 275 "utility.c"
			{
				GFileInfo* info = NULL;
				GFile* _tmp14_ = NULL;
				GFileInfo* _tmp15_ = NULL;
				GFileInfo* _tmp16_ = NULL;
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_tmp14_ = file;
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_tmp15_ = g_file_query_info (_tmp14_, G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				info = _tmp15_;
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 289 "utility.c"
					goto __catch11_g_error;
				}
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_tmp16_ = info;
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				if (_tmp16_ != NULL) {
#line 296 "utility.c"
					GFileInfo* _tmp17_ = NULL;
					gchar* _tmp18_ = NULL;
					const gchar* _tmp19_ = NULL;
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
					_tmp17_ = info;
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
					_tmp18_ = g_file_info_get_attribute_as_string (_tmp17_, G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
					_g_free0 (path);
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
					path = _tmp18_;
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
					_tmp19_ = path;
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
					g_debug ("utility.vala:86: Path is %s", _tmp19_);
#line 312 "utility.c"
				}
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_g_object_unref0 (info);
#line 316 "utility.c"
			}
			goto __finally11;
			__catch11_g_error:
			{
				GError* e = NULL;
				GFile* _tmp20_ = NULL;
				gchar* _tmp21_ = NULL;
				gchar* _tmp22_ = NULL;
				GError* _tmp23_ = NULL;
				const gchar* _tmp24_ = NULL;
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				e = _inner_error_;
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_inner_error_ = NULL;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_tmp20_ = file;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_tmp21_ = g_file_get_path (_tmp20_);
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_tmp22_ = _tmp21_;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_tmp23_ = e;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_tmp24_ = _tmp23_->message;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				g_debug ("utility.vala:90: Error occured while reading %s: %s", _tmp22_, _tmp24_);
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_g_free0 (_tmp22_);
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_g_error_free0 (e);
#line 347 "utility.c"
			}
			__finally11:
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_g_object_unref0 (file);
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_g_free0 (path);
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				g_clear_error (&_inner_error_);
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				return NULL;
#line 362 "utility.c"
			}
#line 78 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_g_object_unref0 (file);
#line 366 "utility.c"
		}
	}
#line 96 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	gdk_error_trap_pop_ignored ();
#line 97 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	result = path;
#line 97 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	return result;
#line 375 "utility.c"
}


/**
         * Helper method performing given accelerator on current active
         * window.
         *
         * @param accelerator accelerator parsable by Gtk.accelerator_parse
         * @param press true for press key; false for releasing
         * @param delay delay in milli seconds
         * @return true if creation was successful; otherwise false.
         */
gboolean diodon_utility_perform_key_event (const gchar* accelerator, gboolean press, gulong delay) {
	gboolean result = FALSE;
	guint keysym = 0U;
	GdkModifierType modifiers = 0;
	const gchar* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	GdkModifierType _tmp2_ = 0;
	Display* display = NULL;
	Display* _tmp3_ = NULL;
	gint keycode = 0;
	Display* _tmp4_ = NULL;
	guint _tmp5_ = 0U;
	guchar _tmp6_ = '\0';
	gint _tmp7_ = 0;
#line 109 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	g_return_val_if_fail (accelerator != NULL, FALSE);
#line 114 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp0_ = accelerator;
#line 114 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	gtk_accelerator_parse (_tmp0_, &_tmp1_, &_tmp2_);
#line 114 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	keysym = _tmp1_;
#line 114 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	modifiers = _tmp2_;
#line 115 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp3_ = gdk_x11_get_default_xdisplay ();
#line 115 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	display = _tmp3_;
#line 116 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp4_ = display;
#line 116 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp5_ = keysym;
#line 116 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp6_ = XKeysymToKeycode (_tmp4_, (gulong) _tmp5_);
#line 116 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	keycode = (gint) _tmp6_;
#line 118 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp7_ = keycode;
#line 118 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	if (_tmp7_ != 0) {
#line 428 "utility.c"
		GdkModifierType _tmp8_ = 0;
		GdkModifierType _tmp15_ = 0;
		Display* _tmp22_ = NULL;
		gint _tmp23_ = 0;
		gboolean _tmp24_ = FALSE;
		gulong _tmp25_ = 0UL;
#line 120 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp8_ = modifiers;
#line 120 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		if ((_tmp8_ & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
#line 439 "utility.c"
			gint modcode = 0;
			Display* _tmp9_ = NULL;
			guchar _tmp10_ = '\0';
			Display* _tmp11_ = NULL;
			gint _tmp12_ = 0;
			gboolean _tmp13_ = FALSE;
			gulong _tmp14_ = 0UL;
#line 121 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp9_ = display;
#line 121 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp10_ = XKeysymToKeycode (_tmp9_, (gulong) GDK_KEY_Control_L);
#line 121 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			modcode = (gint) _tmp10_;
#line 122 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp11_ = display;
#line 122 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp12_ = modcode;
#line 122 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp13_ = press;
#line 122 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp14_ = delay;
#line 122 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			XTestFakeKeyEvent (_tmp11_, (guint) _tmp12_, _tmp13_, _tmp14_);
#line 463 "utility.c"
		}
#line 124 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp15_ = modifiers;
#line 124 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		if ((_tmp15_ & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) {
#line 469 "utility.c"
			gint modcode = 0;
			Display* _tmp16_ = NULL;
			guchar _tmp17_ = '\0';
			Display* _tmp18_ = NULL;
			gint _tmp19_ = 0;
			gboolean _tmp20_ = FALSE;
			gulong _tmp21_ = 0UL;
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp16_ = display;
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp17_ = XKeysymToKeycode (_tmp16_, (gulong) GDK_KEY_Shift_L);
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			modcode = (gint) _tmp17_;
#line 126 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp18_ = display;
#line 126 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp19_ = modcode;
#line 126 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp20_ = press;
#line 126 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp21_ = delay;
#line 126 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			XTestFakeKeyEvent (_tmp18_, (guint) _tmp19_, _tmp20_, _tmp21_);
#line 493 "utility.c"
		}
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp22_ = display;
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp23_ = keycode;
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp24_ = press;
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp25_ = delay;
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		XTestFakeKeyEvent (_tmp22_, (guint) _tmp23_, _tmp24_, _tmp25_);
#line 131 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		result = TRUE;
#line 131 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		return result;
#line 509 "utility.c"
	}
#line 134 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	result = FALSE;
#line 134 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	return result;
#line 515 "utility.c"
}


static Window diodon_utility_get_active_window (void) {
	Window result = 0;
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_ = NULL;
	GdkWindow* active_window = NULL;
	GdkScreen* _tmp1_ = NULL;
	GdkWindow* _tmp2_ = NULL;
	GdkWindow* _tmp3_ = NULL;
#line 139 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp0_ = gdk_screen_get_default ();
#line 139 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	screen = _tmp0_;
#line 140 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp1_ = screen;
#line 140 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp2_ = gdk_screen_get_active_window (_tmp1_);
#line 140 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	active_window = _tmp2_;
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp3_ = active_window;
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	if (_tmp3_ != NULL) {
#line 541 "utility.c"
		Window xactive_window = 0;
		GdkWindow* _tmp4_ = NULL;
		Window _tmp5_ = 0;
		Window _tmp6_ = 0;
#line 142 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp4_ = active_window;
#line 142 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp5_ = gdk_x11_window_get_xid (_tmp4_);
#line 142 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		xactive_window = _tmp5_;
#line 143 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp6_ = xactive_window;
#line 143 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		g_debug ("utility.vala:143: Active window %#x", (guint) ((gint) _tmp6_));
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		result = xactive_window;
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_g_object_unref0 (active_window);
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		return result;
#line 562 "utility.c"
	}
#line 147 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	result = (Window) None;
#line 147 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_g_object_unref0 (active_window);
#line 147 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	return result;
#line 570 "utility.c"
}


static gulong diodon_utility_get_pid (Window window) {
	gulong result = 0UL;
	Display* display = NULL;
	Display* _tmp0_ = NULL;
	Atom wm_pid = {0};
	Display* _tmp1_ = NULL;
	Atom _tmp2_ = {0};
	Atom _tmp3_ = {0};
#line 152 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp0_ = gdk_x11_get_default_xdisplay ();
#line 152 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	display = _tmp0_;
#line 153 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp1_ = display;
#line 153 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp2_ = XInternAtom (_tmp1_, "_NET_WM_PID", FALSE);
#line 153 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	wm_pid = _tmp2_;
#line 155 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	_tmp3_ = wm_pid;
#line 155 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	if (_tmp3_ != ((Atom) None)) {
#line 596 "utility.c"
		Atom actual_type_return = {0};
		gint actual_format_return = 0;
		gulong nitems_return = 0UL;
		gulong bytes_after_return = 0UL;
		void* prop_return = NULL;
		gint status = 0;
		Display* _tmp4_ = NULL;
		Window _tmp5_ = 0;
		Atom _tmp6_ = {0};
		Atom _tmp7_ = {0};
		gint _tmp8_ = 0;
		gulong _tmp9_ = 0UL;
		gulong _tmp10_ = 0UL;
		void* _tmp11_ = NULL;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		prop_return = NULL;
#line 162 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp4_ = display;
#line 162 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp5_ = window;
#line 162 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp6_ = wm_pid;
#line 162 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp12_ = XGetWindowProperty (_tmp4_, _tmp5_, _tmp6_, (glong) 0, G_MAXLONG, FALSE, (Atom) 0, &_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_, (unsigned char **) (&_tmp11_));
#line 162 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		actual_type_return = _tmp7_;
#line 162 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		actual_format_return = _tmp8_;
#line 162 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		nitems_return = _tmp9_;
#line 162 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		bytes_after_return = _tmp10_;
#line 162 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		prop_return = _tmp11_;
#line 162 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		status = _tmp12_;
#line 166 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp13_ = status;
#line 166 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		_tmp14_ = Success;
#line 166 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
		if (_tmp13_ == _tmp14_) {
#line 642 "utility.c"
			void* _tmp15_ = NULL;
#line 167 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			_tmp15_ = prop_return;
#line 167 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
			if (_tmp15_ != NULL) {
#line 648 "utility.c"
				gulong pid = 0UL;
				void* _tmp16_ = NULL;
				gulong _tmp17_ = 0UL;
				void* _tmp18_ = NULL;
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_tmp16_ = prop_return;
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				pid = *((gulong*) _tmp16_);
#line 169 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_tmp17_ = pid;
#line 169 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				g_debug ("utility.vala:169: Copied by process with pid %lu", _tmp17_);
#line 170 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				_tmp18_ = prop_return;
#line 170 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				XFree (_tmp18_);
#line 171 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				result = pid;
#line 171 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
				return result;
#line 669 "utility.c"
			}
		}
	}
#line 176 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	result = (gulong) 0;
#line 176 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	return result;
#line 677 "utility.c"
}


DiodonUtility* diodon_utility_construct (GType object_type) {
	DiodonUtility * self = NULL;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	self = (DiodonUtility*) g_object_new (object_type, NULL);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	return self;
#line 687 "utility.c"
}


static void diodon_utility_class_init (DiodonUtilityClass * klass) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/utility.vala"
	diodon_utility_parent_class = g_type_class_peek_parent (klass);
#line 694 "utility.c"
}


static void diodon_utility_instance_init (DiodonUtility * self) {
}


/**
     * Class for defining utility methods to be used in any part of diodon.
     */
GType diodon_utility_get_type (void) {
	static volatile gsize diodon_utility_type_id__volatile = 0;
	if (g_once_init_enter (&diodon_utility_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DiodonUtilityClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diodon_utility_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DiodonUtility), 0, (GInstanceInitFunc) diodon_utility_instance_init, NULL };
		GType diodon_utility_type_id;
		diodon_utility_type_id = g_type_register_static (G_TYPE_OBJECT, "DiodonUtility", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&diodon_utility_type_id__volatile, diodon_utility_type_id);
	}
	return diodon_utility_type_id__volatile;
}



